ChangeSet 1.1001, 2003/02/20 11:12:24-08:00, oliver@neukum.name

[PATCH] USB: kaweth length calculation fix

this is a fix for the DHCP problem people have reported.

  - fix dhcp problem by correct length calculation
  Thanks to Oliver Kurth


diff -Nru a/drivers/usb/kaweth.c b/drivers/usb/kaweth.c
--- a/drivers/usb/kaweth.c	Thu Feb 20 12:06:56 2003
+++ b/drivers/usb/kaweth.c	Thu Feb 20 12:06:56 2003
@@ -700,7 +700,7 @@
 static int kaweth_start_xmit(struct sk_buff *skb, struct net_device *net)
 {
 	struct kaweth_device *kaweth = net->priv;
-	char *private_header;
+	u16 *private_header;
 
 	int res;
 
@@ -732,7 +732,7 @@
 	}
 
 	private_header = __skb_push(skb, 2);
-	*private_header = cpu_to_le16(skb->len);
+	*private_header = cpu_to_le16(skb->len-2);
 	kaweth->tx_skb = skb;
 
 	FILL_BULK_URB(kaweth->tx_urb,
